config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.libvirt.new

# If not already there, start the daemon from /etc/rc.d/rc.local
if [ ! "$(grep rc\.libvirt etc/rc.d/rc.local)" ]; then
  cat << EOF >> etc/rc.d/rc.local

# Start libvirt:
if [ -x /etc/rc.d/rc.libvirt ]; then
  /etc/rc.d/rc.libvirt start
fi
EOF
fi
( cd etc/libvirt/qemu/networks/autostart ; rm -rf default.xml )
( cd etc/libvirt/qemu/networks/autostart ; ln -sf ../default.xml default.xml )
( cd usr/lib64 ; rm -rf libvirt-admin.so )
( cd usr/lib64 ; ln -sf libvirt-admin.so.0 libvirt-admin.so )
( cd usr/lib64 ; rm -rf libvirt-admin.so.0 )
( cd usr/lib64 ; ln -sf libvirt-admin.so.0.12000.0 libvirt-admin.so.0 )
( cd usr/lib64 ; rm -rf libvirt-lxc.so )
( cd usr/lib64 ; ln -sf libvirt-lxc.so.0 libvirt-lxc.so )
( cd usr/lib64 ; rm -rf libvirt-lxc.so.0 )
( cd usr/lib64 ; ln -sf libvirt-lxc.so.0.12000.0 libvirt-lxc.so.0 )
( cd usr/lib64 ; rm -rf libvirt-qemu.so )
( cd usr/lib64 ; ln -sf libvirt-qemu.so.0 libvirt-qemu.so )
( cd usr/lib64 ; rm -rf libvirt-qemu.so.0 )
( cd usr/lib64 ; ln -sf libvirt-qemu.so.0.12000.0 libvirt-qemu.so.0 )
( cd usr/lib64 ; rm -rf libvirt.so )
( cd usr/lib64 ; ln -sf libvirt.so.0 libvirt.so )
( cd usr/lib64 ; rm -rf libvirt.so.0 )
( cd usr/lib64 ; ln -sf libvirt.so.0.12000.0 libvirt.so.0 )
